Add-Type -AssemblyName System.Windows.Forms
Add-Type -AssemblyName System.Drawing
  
  $global:srv = $null
   $global:scr = $null 

$Token2TOTPRadius = New-Object system.Windows.Forms.Form
$Token2TOTPRadius.Text = "Token2 TOTPRadius | ADFS Adapter"
$Token2TOTPRadius.TopMost = $true
$Token2TOTPRadius.Width = 450
$Token2TOTPRadius.Height = 330

$fqdn = New-Object system.windows.Forms.TextBox
$fqdn.Width = 187
$fqdn.Height = 20
$fqdn.location = new-object system.drawing.point(171,31)
$fqdn.Font = "Microsoft Sans Serif,10"
$fqdn.Text="10.24.63.82"
$Token2TOTPRadius.controls.Add($fqdn)

$label3 = New-Object system.windows.Forms.Label
$label3.Text = "TOTPRadius FQDN "
$label3.AutoSize = $true
$label3.Width = 25
$label3.Height = 10
$label3.location = new-object system.drawing.point(28,32)
$label3.Font = "Microsoft Sans Serif,10"

$Token2TOTPRadius.controls.Add($label3)

$label4 = New-Object system.windows.Forms.Label
$label4.Text = "RADIUS Shared secret"
$label4.AutoSize = $true
$label4.Width = 25
$label4.Height = 10
$label4.location = new-object system.drawing.point(12,63)
$label4.Font = "Microsoft Sans Serif,10"

$Token2TOTPRadius.controls.Add($label4)

$secret = New-Object system.windows.Forms.TextBox
$secret.Width = 185
$secret.Height = 20
$secret.location = new-object system.drawing.point(172,63)
$secret.Font = "Microsoft Sans Serif,10"
$secret.Text="ac9cl5wm20pb"
$Token2TOTPRadius.controls.Add($secret)



$label5 = New-Object system.windows.Forms.Label
$label5.Text = "Web API Key"
$label5.AutoSize = $true
$label5.Width = 25
$label5.Height = 10
$label5.location = new-object system.drawing.point(68,93)
$label5.Font = "Microsoft Sans Serif,10"

$Token2TOTPRadius.controls.Add($label5)


$api = New-Object system.windows.Forms.TextBox
$api.Width = 185
$api.Height = 20
$api.location = new-object system.drawing.point(172,93)
$api.Font = "Microsoft Sans Serif,10"
$api.Text="ws4uhpdicf5j"
$Token2TOTPRadius.controls.Add($api)



$label6 = New-Object system.windows.Forms.Label
$label6.Text = "Web API protocol"
$label6.AutoSize = $true
$label6.Width = 25
$label6.Height = 10
$label6.location = new-object system.drawing.point(68,123)
$label5.Font = "Microsoft Sans Serif,10"

$Token2TOTPRadius.controls.Add($label6)



$DropDownBox = New-Object System.Windows.Forms.ComboBox
$DropDownBox.Location = New-Object System.Drawing.Size(172,123) 
$DropDownBox.Size = New-Object System.Drawing.Size(80,20) 
$DropDownBox.DropDownHeight = 200 
$DropDownBox.Text="https"
$Token2TOTPRadius.Controls.Add($DropDownBox) 

$wksList=@("https","http")

foreach ($wks in $wksList) {
                      $DropDownBox.Items.Add($wks)
                              } #end foreach



$button6 = New-Object system.windows.Forms.Button
$button6.Text = "Install"
$button6.Width = 60
$button6.Height = 30
$button6.Add_Click({
#add here code triggered by the event
$global:srv =$fqdn.Text
$global:scr =$secret.Text
$global:protocol =$DropDownBox.Text
$global:api =$api.Text
if (($secret.Text -ne "") -and (  $fqdn.Text -ne "" ) )  
{
$Token2TOTPRadius.Dispose()
 String $server = $fqdn.Text.ToString()
  $server

 
Write-Host "Creating required registry keys"
New-Item -Path "HKLM:\SOFTWARE\Token2" -Force | Out-Null
New-Item -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Force  | Out-Null

New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "Server" -Value $global:srv | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "AuthenticationPort" -Value "1812" | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "AccountingPort" -Value "1813" | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "TimeOut" -Value "3000" | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "SharedSecret" -Value $global:scr | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "API" -Value $global:api | Out-Null
New-ItemProperty -Path "HKLM:\SOFTWARE\Token2\RadiusAuthenticationAdapter" -Name "Protocol" -Value $global:protocol | Out-Null
 

#
# Copy files to the right locations
Write-Host "Copying files to $env:programfiles"
New-Item -ItemType Directory "$env:programfiles\Token2\RadiusAuthenticationAdapter" | Out-Null
Copy-Item RadiusAuthenticationAdapter.dll "$env:programfiles\Token2\RadiusAuthenticationAdapter" | Out-Null
Copy-Item Radius.dll "$env:programfiles\Token2\RadiusAuthenticationAdapter" | Out-Null
#Set-location "$env:programfiles\Token2\RadiusAuthenticationAdapter"

#
# Install assemblies into GAC.
Write-Host "Installing assemblies into the GAC"
[System.Reflection.Assembly]::Load("System.EnterpriseServices, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a") | Out-Null
$publish = New-Object System.EnterpriseServices.Internal.Publish
$publish.GacInstall("$env:programfiles\Token2\RadiusAuthenticationAdapter\Radius.dll")
$publish.GacInstall("$env:programfiles\Token2\RadiusAuthenticationAdapter\RadiusAuthenticationAdapter.dll")

#
# Create EventLog source
Write-Host "Creating EventLog source"
if ([System.Diagnostics.EventLog]::SourceExists("Token2 TOTPRADIUS Authentication Adapter") -eq $false) {
	[System.Diagnostics.EventLog]::CreateEventSource("Token2 TOTPRADIUS Authentication Adapter", $null)
}

#
# Prompt before continuing
#Write-Host "Review the above and Press Y continue and register the Authentication Adapter. CTRL-C to exit"
#$response = read-host
#if ( $response -ne "Y" )
#{
#	Write-Host "Aborted"
#	exit	
#}


#
# Register AD:FS Authentication Adapter
$typeName = "RadiusAuthenticationAdapter.AuthenticationAdapter, RadiusAuthenticationAdapter, Version=1.0.0.0, Culture=neutral, PublicKeyToken=df3dcc9092cc3d3c"
Register-AdfsAuthenticationProvider -TypeName $typeName -Name "TOTPRadiusAuthenticationAdapter" -Verbose

} 
Else {

[System.Windows.Forms.MessageBox]::Show($fqdn.Text)

}
} )
$button6.location = new-object system.drawing.point(341,171)
$button6.Font = "Microsoft Sans Serif,10"
$Token2TOTPRadius.controls.Add($button6)

$label7 = New-Object system.windows.Forms.Label
$label7.Text = "This script is to be run as Admin. ADFS Service needs to be restarted to take effect. "
$label7.AutoSize = $true
$label7.Width = 25
$label7.Height = 10
$label7.location = new-object system.drawing.point(16,228)
$label7.Font = "Microsoft Sans Serif,8"
$Token2TOTPRadius.controls.Add($label7)

[void]$Token2TOTPRadius.ShowDialog()
$Token2TOTPRadius.Dispose()